# MQTT
## /cabinet/{cabinet_number}
Cabinet receives commands
```js
    {
        "release": {number}
    }
```
`number` is the number of times cabinet is released,
`cabinet_number` is the cabinet number

## /cabinet/{cabinet_number}/sensor
Cabinet publishes sensor status
```js
    {
        "sensor" :{status}
    }
```
`status` can be `empty`, `low`, `half`, or `full`

## /cabinet/screen
Screen receives cabinet statuses
```js
    {
        "cabinet1":{status},
        "cabinet2":{status},
        ...
        "cabinetn":{status}
    }
```
`cabinet` ranges from 1 to number of cabinets, `status` can be `empty`, `low`, `half`, or `full`

## /cabinet/detect
Avoidance sensor sends detection
```js
    {
        "detect":true
    }
```

## /cabinet/keypad
Keypad publishes key presses
```js
    {
        "detect":true
    }
```

# HTTP

## GET /cabinet
Returns cabinet status
```js
    {
        "status": "success",
        "cabinets" : [
            {status}
            ...
            {status}
        ]
    }
```
`status` can be `empty`, `low`, `half`, or `full`, `status` elements for each cabinet

## GET /order
Returns order list
```js
    {
        "status" : "success",
        "order" : {
            "order_id" : {
                "1" : 2,
                "2" : 3,
                "3" : 4
            },
            "order_id" : {
                "1" : 2,
                "2" : 3,
                "3" : 4
            },
        }
    }
```

## POST /order/submit
Submits order

Input
```js
    {
        "order" : {
            "1" : 2,
            "2" : 3,
            "3" : 4
        }
    }
```

Output
```js
    {
        "status" : "success"
        "order_id" : {id}
    }
```
`order` is medicine order in the form of cabinet number : count
`id` is the order id