
#include <WiFi.h>
#include <PubSubClient.h>
#include <ArduinoJson.h>
#include <string.h>
int led = 2;      // LED pin on arduino
int detectorPin = 36;  // obstacle avoidance sensor interface
int val;              // variable to store result
bool detected = false;
int led_out = 22;
int ldr_read = 34;


#define ssid "ZisZtR"
#define password "test12345"


#define mqtt_server "broker.emqx.io"
#define mqtt_port 1883
#define mqtt_user ""
#define mqtt_password ""
#define mqtt_name "test_mqtt_avoidance"


WiFiClient espClient; // Initial client instance
PubSubClient client(espClient);


void Connect_Wifi(){
  WiFi.disconnect();
  delay(500);
  WiFi.begin(ssid, password);
  Serial.print("Connecting to WiFi");
  while (WiFi.status() != WL_CONNECTED)
  {
    delay(500);
    Serial.print(".");
  }
  Serial.print("OK! IP=");
  Serial.println(WiFi.localIP());
}


void setup()
{
  Serial.begin(115200);
  pinMode(led, OUTPUT);  // Define LED as output interface
  pinMode(detectorPin, INPUT);  // Define obstacle avoidance sensor as input interface
  pinMode(led_out, OUTPUT);
  digitalWrite(led_out, HIGH);
  pinMode(ldr_read, INPUT);


  Connect_Wifi();
  client.setServer(mqtt_server, mqtt_port);
}
void loop()
{
  val = digitalRead(detectorPin);   // read sensor value
  int val_ldr = analogRead(ldr_read);
  Serial.println(val_ldr);


  if (val == HIGH) // If a signal is detected, the LED will light up.
  {
    // Serial.println("No obstacle");
    detected = false;
    digitalWrite(led, LOW);
  }
  else if (!detected)
  {
    detected = !detected;
    Serial.println("Obstacle detected");
    digitalWrite(led, HIGH);
   
    String json;
    DynamicJsonDocument doc(1024);
    doc["detect"] = true;
    serializeJson(doc, json);
    const char *json_char = json.c_str();
    if(client.connect(mqtt_name,mqtt_user,mqtt_password)){
      client.publish("/cabinet/detect", json_char);
      Serial.println("published");
    }else{
      Serial.println("failed");
    }    
    client.loop();
  }


  delay(100); // Break of 500ms between each measurement
}


