#include <Keypad.h>
#include <WiFi.h>
#include <PubSubClient.h>
#include <ArduinoJson.h>
#include <string.h>
#include <Wire.h>
#include <LiquidCrystal_I2C.h>


#define ssid "<SSID_HERE>"
#define password "<PASSWORD HERE>"


#define mqtt_server "broker.emqx.io"
#define mqtt_port 1883
#define mqtt_user ""
#define mqtt_password ""
#define mqtt_name "test_mqtt_keypad"
#define ROW_NUM     4 // four rows
#define COLUMN_NUM  4 // four columns


WiFiClient espClient; // Initial client instance
PubSubClient client(espClient);


char keys[ROW_NUM][COLUMN_NUM] = {
  {'1', '2', '3', 'A'},
  {'4', '5', '6', 'B'},
  {'7', '8', '9', 'C'},
  {'*', '0', '#', 'D'}
};


byte pin_rows[ROW_NUM]      = {19, 18, 5, 17}; // GIOP19, GIOP18, GIOP5, GIOP17 connect to the row pins
byte pin_column[COLUMN_NUM] = {16, 4, 0, 2};   // GIOP16, GIOP4, GIOP0, GIOP2 connect to the column pins


Keypad keypad = Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );


void Connect_Wifi();


void setup() {
  Serial.begin(115200);


  /* Connect to WiFi */
  Connect_Wifi();


  /* MQTT setup */
  client.setServer(mqtt_server, mqtt_port);
  client.setCallback(callback);    
}


void loop() {
  char key = keypad.getKey();


  if (key) {
    Serial.println(key);
    String json;
    DynamicJsonDocument doc(2048);
    doc["cabinet"] = String(key);
    serializeJson(doc, json);
    const char *json_char = json.c_str();
    if(client.connect(mqtt_name,mqtt_user,mqtt_password)){
        client.publish("/cabinet/keypad", json_char); // publish message ไปที่ /test/number1
    }else{
        Serial.println("failed");
    }    
    client.loop();
  }  
}


void Connect_Wifi(){
    WiFi.begin(ssid, password);
    Serial.print("Connecting to WiFi");
    while (WiFi.status() != WL_CONNECTED)
    {
        delay(500);
        Serial.print(".");
    }
    Serial.print("OK! IP=");
    Serial.println(WiFi.localIP());
}


void callback(char* topic, byte* payload, unsigned int length){
  Serial.print("Message arrived [");
  Serial.print(topic); //ใน mqtx ต้องใส่ชื่อ topic ในช่อง topic
  Serial.print("] ");
  DynamicJsonDocument doc(2048);
  deserializeJson(doc, payload);
  int activate = doc["order_id"];
  Serial.print("order_ID : ");
  Serial.println(activate);
  int control = doc["control"];
  Serial.print("control : ");
  Serial.println(control);  
}
